using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text.RegularExpressions;

using Syncfusion.XlsIO;
using Syncfusion.Windows.Forms;
using Syncfusion.GridExcelConverter;
using Syncfusion.Windows.Forms.Grid;

namespace _41388
{
	/// <summary>
	/// Summary description for Edit.
	/// </summary>
	public class EditExcel : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager mainFrameBarManager;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar mainMenu;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem fileParentBarItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem newParentBarItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar standardToolBar;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem openBarItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem saveBarItem;
		internal Syncfusion.Windows.Forms.Tools.XPMenus.BarItem workSheetBarItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem workBookBarItem;
		private System.ComponentModel.IContainer components;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem exitBarItem;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.StatusBarPanel statusBarPanel1;
		private System.Windows.Forms.StatusBarPanel dateSBPanel;
		private System.Windows.Forms.StatusBarPanel timeSBPanel;

		private int childWorkBookNumber = 0;
		private System.Windows.Forms.ImageList imageList;
		private System.Windows.Forms.Panel panel1;
		public  System.Windows.Forms.TreeView tvwCode;
		private System.Windows.Forms.Splitter splitter1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem4;
		internal WorkBook workBook = null;
		public EditExcel()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			Timer timer = new Timer();
			timer.Enabled = true;
			timer.Interval = 100;
			timer.Tick += new EventHandler(timer_Tick);
			this.WindowState = FormWindowState.Maximized;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(EditExcel));
			this.mainFrameBarManager = new Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(this.components, this);
			this.mainMenu = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "MainMenu");
			this.fileParentBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.newParentBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.workBookBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.workSheetBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.openBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.saveBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.exitBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.standardToolBar = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "StandardToolBar");
			this.imageList = new System.Windows.Forms.ImageList(this.components);
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.statusBarPanel1 = new System.Windows.Forms.StatusBarPanel();
			this.dateSBPanel = new System.Windows.Forms.StatusBarPanel();
			this.timeSBPanel = new System.Windows.Forms.StatusBarPanel();
			this.panel1 = new System.Windows.Forms.Panel();
			this.tvwCode = new System.Windows.Forms.TreeView();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem4 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dateSBPanel)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.timeSBPanel)).BeginInit();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainFrameBarManager
			// 
			this.mainFrameBarManager.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("mainFrameBarManager.BarPositionInfo")));
			this.mainFrameBarManager.Bars.Add(this.mainMenu);
			this.mainFrameBarManager.Bars.Add(this.standardToolBar);
			this.mainFrameBarManager.Categories.Add("windows");
			this.mainFrameBarManager.Categories.Add("File");
			this.mainFrameBarManager.CurrentBaseFormType = "";
			this.mainFrameBarManager.Form = this;
			this.mainFrameBarManager.ImageList = this.imageList;
			this.mainFrameBarManager.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											 this.fileParentBarItem,
																											 this.newParentBarItem,
																											 this.openBarItem,
																											 this.saveBarItem,
																											 this.workSheetBarItem,
																											 this.workBookBarItem,
																											 this.exitBarItem,
																											 this.barItem1,
																											 this.barItem2,
																											 this.barItem3,
																											 this.barItem4});
			this.mainFrameBarManager.LargeImageList = null;
			this.mainFrameBarManager.ResetCustomization = false;
			// 
			// mainMenu
			// 
			this.mainMenu.AllowHiding = false;
			this.mainMenu.BarName = "MainMenu";
			this.mainMenu.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)(((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsMainMenu | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder)));
			this.mainMenu.Caption = "MainMenu";
			this.mainMenu.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																								  this.fileParentBarItem});
			this.mainMenu.Manager = this.mainFrameBarManager;
			// 
			// fileParentBarItem
			// 
			this.fileParentBarItem.CategoryIndex = 1;
			this.fileParentBarItem.ID = "File";
			this.fileParentBarItem.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										   this.newParentBarItem,
																										   this.openBarItem,
																										   this.saveBarItem,
																										   this.exitBarItem});
			this.fileParentBarItem.Text = "File";
			// 
			// newParentBarItem
			// 
			this.newParentBarItem.CategoryIndex = 1;
			this.newParentBarItem.ID = "New";
			this.newParentBarItem.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										  this.workBookBarItem,
																										  this.workSheetBarItem});
			this.newParentBarItem.Style = Syncfusion.Windows.Forms.VisualStyle.OfficeXP;
			this.newParentBarItem.Text = "New";
			// 
			// workBookBarItem
			// 
			this.workBookBarItem.CategoryIndex = 1;
			this.workBookBarItem.ID = "WorkBook";
			this.workBookBarItem.Text = "WorkBook";
			this.workBookBarItem.Click += new System.EventHandler(this.workBookBarItem_Click);
			// 
			// workSheetBarItem
			// 
			this.workSheetBarItem.CategoryIndex = 1;
			this.workSheetBarItem.Enabled = false;
			this.workSheetBarItem.ID = "WorkSheet";
			this.workSheetBarItem.ImageIndex = 0;
			this.workSheetBarItem.Text = "WorkSheet";
			this.workSheetBarItem.Click += new System.EventHandler(this.workSheetBarItem_Click);
			// 
			// openBarItem
			// 
			this.openBarItem.CategoryIndex = 1;
			this.openBarItem.ID = "open";
			this.openBarItem.ImageIndex = 1;
			this.openBarItem.Text = "Open";
			this.openBarItem.Click += new System.EventHandler(this.openBarItem_Click);
			// 
			// saveBarItem
			// 
			this.saveBarItem.CategoryIndex = 1;
			this.saveBarItem.ID = "Save";
			this.saveBarItem.ImageIndex = 2;
			this.saveBarItem.Text = "Save";
			this.saveBarItem.Click += new System.EventHandler(this.saveBarItem_Click);
			// 
			// exitBarItem
			// 
			this.exitBarItem.CategoryIndex = 1;
			this.exitBarItem.ID = "Exit";
			this.exitBarItem.Text = "Exit";
			this.exitBarItem.Click += new System.EventHandler(this.exitBarItem_Click);
			// 
			// standardToolBar
			// 
			this.standardToolBar.BarName = "StandardToolBar";
			this.standardToolBar.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.RotateWhenVertical) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder)));
			this.standardToolBar.Caption = "StandardToolBar";
			this.standardToolBar.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										 this.workSheetBarItem,
																										 this.openBarItem,
																										 this.saveBarItem});
			this.standardToolBar.Manager = this.mainFrameBarManager;
			// 
			// imageList
			// 
			this.imageList.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList.ImageStream")));
			this.imageList.TransparentColor = System.Drawing.Color.Cyan;
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 490);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.statusBarPanel1,
																						  this.dateSBPanel,
																						  this.timeSBPanel});
			this.statusBar1.ShowPanels = true;
			this.statusBar1.Size = new System.Drawing.Size(988, 24);
			this.statusBar1.TabIndex = 5;
			this.statusBar1.Text = "statusBar1";
			// 
			// statusBarPanel1
			// 
			this.statusBarPanel1.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarPanel1.Width = 952;
			// 
			// dateSBPanel
			// 
			this.dateSBPanel.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.dateSBPanel.Width = 10;
			// 
			// timeSBPanel
			// 
			this.timeSBPanel.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.timeSBPanel.Width = 10;
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.tvwCode);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel1.Location = new System.Drawing.Point(0, 51);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(112, 439);
			this.panel1.TabIndex = 7;
			// 
			// tvwCode
			// 
			this.tvwCode.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tvwCode.ImageIndex = -1;
			this.tvwCode.Location = new System.Drawing.Point(0, 0);
			this.tvwCode.Name = "tvwCode";
			this.tvwCode.SelectedImageIndex = -1;
			this.tvwCode.Size = new System.Drawing.Size(112, 439);
			this.tvwCode.TabIndex = 0;
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(112, 51);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(6, 439);
			this.splitter1.TabIndex = 8;
			this.splitter1.TabStop = false;
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = 0;
			this.barItem1.ID = "Cascade";
			this.barItem1.Text = "Cascade";
			this.barItem1.Click += new System.EventHandler(this.barItem1_Click);
			// 
			// barItem2
			// 
			this.barItem2.CategoryIndex = 0;
			this.barItem2.ID = "Horizontal";
			this.barItem2.Text = "Horizontal";
			this.barItem2.Click += new System.EventHandler(this.barItem2_Click);
			// 
			// barItem3
			// 
			this.barItem3.CategoryIndex = 0;
			this.barItem3.ID = "Vertical";
			this.barItem3.Text = "Vertical";
			this.barItem3.Click += new System.EventHandler(this.barItem3_Click);
			// 
			// barItem4
			// 
			this.barItem4.CategoryIndex = 1;
			this.barItem4.ID = "Cascade_1";
			this.barItem4.Text = "Cascade";
			// 
			// EditExcel
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(988, 514);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.statusBar1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.IsMdiContainer = true;
			this.Name = "EditExcel";
			this.Text = "EditExcel";
			this.Load += new System.EventHandler(this.EditExcel_Load);
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dateSBPanel)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.timeSBPanel)).EndInit();
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion



		private void timer_Tick(object sender, EventArgs e)
		{
			DateTime dt = DateTime.Now;
			this.timeSBPanel.Text = dt.ToShortTimeString();
			this.dateSBPanel.Text = dt.ToLongDateString();
		}


		private void workBookBarItem_Click(object sender, System.EventArgs e)
		{
			WorkBook workBook = new WorkBook();
			workBook.MdiParent = this;
			workBook.Text = "WorkBook"+childWorkBookNumber++;
			workBook.Show();
		}

		private void workSheetBarItem_Click(object sender, System.EventArgs e)
		{
			this.workBook.insertSheetMenuItem.PerformClick();
		}


		private void saveBarItem_Click(object sender, System.EventArgs e)
		{
			if(this.workBook != null)
			{
				SaveFileDialog saveFileDialog = new SaveFileDialog();
				saveFileDialog.Filter = "Files(*.GXL;*.XLS)|*.GXL;*.XLS";
				saveFileDialog.AddExtension = true;
				saveFileDialog.DefaultExt = ".GXL";
				saveFileDialog.FileName = this.workBook.Text;

				if(saveFileDialog.ShowDialog() == DialogResult.OK && saveFileDialog.CheckPathExists)
				{
					string path = System.IO.Path.GetDirectoryName(saveFileDialog.FileName);

					this.workBook._grid.CurrentCell.EndEdit();
					#region Save GXL File
					if(saveFileDialog.FileName.ToUpper().EndsWith(".GXL"))
					{
						FileStream stream = new FileStream(saveFileDialog.FileName,FileMode.Create);
						BinaryWriter bWriter = new BinaryWriter(stream,System.Text.Encoding.BigEndianUnicode);
						bWriter.Write(this.workBook.tabBarSplitterControl.TabBarPages.Count);
						int i;
						for(i =0;i<this.workBook.tabBarSplitterControl.TabBarPages.Count;i++)
						{
							TabBarPage page = this.workBook.tabBarSplitterControl.TabBarPages[i];
							GridControl _grid = null;
							if(page.Controls[0]!=null && page.Controls[0] is GridControl)
								_grid = page.Controls[0] as GridControl;
							else
								_grid = this.workBook.tabBarSplitterControl.ActivePane as GridControl;

							string fileName = path+string.Format("\\{0}{1}.grd",Path.GetFileNameWithoutExtension(saveFileDialog.FileName),i);
							_grid.Model.SaveBinary(fileName);
							bWriter.Write(page.Text);
			
						}
						bWriter.Close();
						stream.Close();
					}
						#endregion

					#region Save XLS File
					else
						if(saveFileDialog.FileName.ToUpper().EndsWith(".XLS"))
					{	
						IWorkbook workBook = ExcelUtils.CreateWorkbook(this.workBook.tabBarSplitterControl.TabBarPages.Count);
						GridExcelConverterControl gecc = new GridExcelConverterControl();

						for(int i =0;i<this.workBook.tabBarSplitterControl.TabBarPages.Count;i++)
						{
							TabBarPage page = this.workBook.tabBarSplitterControl.TabBarPages[i];
			
							GridControl _grid = null;
							if(page.Controls[0]!=null && page.Controls[0] is GridControl)
								_grid = page.Controls[0] as GridControl;
							else
								_grid = this.workBook.tabBarSplitterControl.ActivePane as GridControl;

							IWorksheet workSheet = workBook.Worksheets[i];
							gecc.GridToExcel(_grid.Model, workSheet);
			
						}

						workBook.SaveAs(saveFileDialog.FileName);
						workBook.Close();
						ExcelUtils.ThrowNotSavedOnDestroy = false;

					}
					#endregion

					this.workBook.Text = Path.GetFileNameWithoutExtension(saveFileDialog.FileName);
				}
			}
		}

		public void DELEt(TreeNode node) 
		{ 
  
			for(int i =0;i<node.Nodes.Count;i++) 
			{    
				TreeNode Tnode = new TreeNode(); 
				Tnode = node.Nodes[i]; 
				if(node.Nodes.Count!=0)
				{
					DELEt(Tnode); 
				}
				else
				{
					Tnode.Remove(); 
					i--;
				}

			} 
		} 

		/*public void GetRoot() 
		{ 
			TreeNode Root = tvwCode.Nodes[0]; 
			DELEt(Root); 
 
		} */


		public void DelNodeText(TreeNodeCollection tncnode)
		{
			foreach(TreeNode node in tncnode)
			{
				if(node.Nodes.Count!=0)
					DelNodeText(node.Nodes);
				else
				{
					//  MessageBox.Show("֦ӽڵ㣬ɾ");
					
					node.Remove();
					return;
				}
			}
		}

		internal void FindNodeText(TreeNodeCollection tnc,string filenamee)
		{
			foreach(TreeNode node in tnc)
			{
				if(node.Nodes.Count!=0)
					FindNodeText(node.Nodes,filenamee);
				if (node.Text==filenamee)
				{
					//  MessageBox.Show("Ϸļ");
					
					DELEt(node);
					//DelNodeText(node.Nodes);
					//return;
				}
			}
		}


        bool openy=false;
		public void GetAllNodeText(TreeNodeCollection tnc,string filenamee)
		{
			foreach(TreeNode node in tnc)
			{
				if(node.Nodes.Count!=0)
					GetAllNodeText(node.Nodes,filenamee);
				if (node.Text==filenamee)
				{
					//  MessageBox.Show("ļѾ򿪣罨½ť1111");
					openy=true;
					return;
				}
			}
		}

		private void openBarItem_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog openFileDialog = new OpenFileDialog();
			openFileDialog.Filter = "Files(*.GXL;*.XLS)|*.GXL;*.XLS";
			if(openFileDialog.ShowDialog() == DialogResult.OK)
			{
				string path = Path.GetDirectoryName(openFileDialog.FileName);

				//жǷļ
				if (tvwCode.Nodes.Count>0)
				{
					GetAllNodeText(tvwCode.Nodes,openFileDialog.FileName);
					if (openy==true)
					{
						MessageBox.Show("ļѾ򿪣罨½ť");
						openy=false;
						goto end;   // should be quit?
					} //*/
				}
				// жϽ

				if(openFileDialog.CheckFileExists)
				{
					WorkBook workBook = new WorkBook();
					workBook.MdiParent = this;
					workBook.Tag = ++childWorkBookNumber;
					workBook.Show();
					this.workBook = workBook;

					for(int i = this.workBook.tabBarSplitterControl.TabBarPages.Count-1;i>=0;i--)
						if(this.workBook.tabBarSplitterControl.ActivePage.Text!= this.workBook.tabBarSplitterControl.TabBarPages[i].Text)
							this.workBook.tabBarSplitterControl.TabBarPages[i].Dispose();
					
					
					#region Open GXL File
					if(openFileDialog.FileName.ToUpper().EndsWith(".GXL"))
					{
						FileStream stream = new FileStream(openFileDialog.FileName,FileMode.Open);
						BinaryReader bReader = new BinaryReader(stream,System.Text.Encoding.BigEndianUnicode);
						//int temp = 0;
						ArrayList pageInfo = new ArrayList();
						int sheetCount = bReader.ReadInt32();
						
						for(int i = 0;i<sheetCount;i++)
						{
							TabBarPage tabBarPage = new TabBarPage(bReader.ReadString());

							GridControl GRID = new GridControl();
							GRID.ContextMenu = this.workBook.gridContextMenu;
							GRID.FloatCellsMode = GridFloatCellsMode.BeforeDisplayCalculation;
							tabBarPage.Controls.Add(GRID);
							this.workBook.tabBarSplitterControl.TabBarPages.Add(tabBarPage);
							string fileName = path+string.Format("\\{0}{1}.grd",Path.GetFileNameWithoutExtension(openFileDialog.FileName),i);
							GRID.Model = GridModel.LoadBinary(fileName);
							this.workBook.PopulateGrid(GRID);////ʽgridʽ
						
						}
						this.workBook.RegisterGrid();
						bReader.Close();
						stream.Close();
					}
						#endregion

					#region Open XLS File
					else
						if(openFileDialog.FileName.ToUpper().EndsWith(".XLS"))
					{

						
						ExcelEngine excelEngine = new ExcelEngine();
						IApplication application = excelEngine.Excel;
						IWorkbook workbook = excelEngine.Excel.Workbooks.Open(openFileDialog.FileName); 

						int i =0;
						GridExcelConverterControl gecc = new GridExcelConverterControl();
						for( i = 0;i<workbook.Worksheets.Count;i++)
						{
							IWorksheet  workSheet = workbook.Worksheets[i];

							TabBarPage tabBarPage = new Syncfusion.Windows.Forms.TabBarPage(workSheet.Name);
							tabBarPage.Text = workSheet.Name;
							GridControl GRID = new GridControl();

							GRID.RowCount = workSheet.UsedRange.End.Row;
							GRID.ColCount = workSheet.UsedRange.End.Column;
							GRID.TableStyle.CellType = "FormulaCell";
							GRID.FloatCellsMode = GridFloatCellsMode.BeforeDisplayCalculation;
							tabBarPage.Controls.Add(GRID);
							this.workBook.tabBarSplitterControl.TabBarPages.Add(tabBarPage);	
							
							for(int r=1;r<=workSheet.UsedRange.End.Row;r++)
								for(int c=1;c<=workSheet.UsedRange.End.Column;c++)
									if(workSheet.Range [r,c].HasFormula ==true)
										if(Regex.Match(workSheet.Range [r,c].Text,"'").Success)
											workSheet.Range [r,c].Text =  Regex.Replace(workSheet.Range [r,c].Text,"'","");
											
										
										
								
							if(workSheet.UsedRange.End.Row > 0 &&workSheet.UsedRange.End.Column>0)
							{
								gecc.ExcelToGrid(workSheet,GRID.Model);
								this.workBook.RegisterGrid();
								GridFormulaEngine engine;
								engine = ((GridFormulaCellModel)(GRID.CellModels["FormulaCell"])).Engine;
								engine.RecalculateRange(GridRangeInfo.Table(), true);

							}
							GRID.RowCount = 1000;
							GRID.ColCount = 1000;	
							this.workBook.PopulateGrid(GRID);  //ʽgridʽ


						}
			
						workbook.Close();
						excelEngine.ThrowNotSavedOnDestroy = false;
						excelEngine.Dispose();
						this.workBook.tabBarSplitterControl.ActivePage = this.workBook.tabBarSplitterControl.TabBarPages[0];
						this.workBook.tabBarSplitterControl.Refresh();

					}
					#endregion

					this.workBook.tabBarSplitterControl.ActivateNextPage(true);
					this.workBook.tabBarSplitterControl.TabBarPages[0].Dispose();
					this.workBook.Text = Path.GetFileNameWithoutExtension(openFileDialog.FileName);

				}

				///////----------/treeview

				int lastindex=tvwCode.Nodes.Count;
				if (lastindex<1)
				{
					// tvwCode.Nodes.Clear();
					TreeNode Mynode=new TreeNode("ʲϸ"); //
					tvwCode.Nodes.Add(Mynode); //һڵ
					Mynode.ImageIndex=0;
					Mynode.SelectedImageIndex=0;

				}
				else
				{
					TreeNode Mynode=tvwCode.Nodes[0];
				}

				TreeNode  Mynodef=new TreeNode(openFileDialog.FileName);
				tvwCode.TopNode.Nodes.Add(Mynodef);
				Mynodef.ImageIndex=1;
				Mynodef.SelectedImageIndex=2;
				//  Document.tabBarSplitterControl1.TabBarPages[0].;

				for (int i = 0; i <this.workBook.tabBarSplitterControl.TabBarPages.Count; i++)
				{
					string nodename=this.workBook.tabBarSplitterControl.TabBarPages[i].Text;
					TreeNode MyNodec=new TreeNode(nodename);
					if  (nodename.IndexOf("_")>0) //(pos('_',nodename)>0)
					{
						bool huiexist=false;

						int ii;
						for (ii=lastindex; ii<tvwCode.Nodes.Count; ii++)
						{
							if (tvwCode.Nodes[ii].Text.IndexOf(nodename.Substring(1,nodename.IndexOf("_"))+"")>0)
							{
								tvwCode.Nodes[ii].Nodes.Add(MyNodec);
								MyNodec.ImageIndex=1;
								MyNodec.SelectedImageIndex=2;
								huiexist=true;
								break;
							}
						}

						if (huiexist==false)
						{
							tvwCode.Nodes[ii].Nodes.Add(MyNodec);
							MyNodec.ImageIndex=1;
							MyNodec.SelectedImageIndex=2;
						}

					}
					else
					{
						Mynodef.Nodes.Add(MyNodec);
						MyNodec.ImageIndex=1;
						MyNodec.SelectedImageIndex=2;
					}
				}
				tvwCode.TopNode.Expand();//׽ڵչ
				Mynodef.Expand();//׽ڵչ
				//Screen.Cursor=crDefault;

				/////////--------------treeview

            end: ;
			}

		}


		private void exitBarItem_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}


		private void EditExcel_Load(object sender, System.EventArgs e)
		{
			this.workBookBarItem.PerformClick();

		}

		private void barItem1_Click(object sender, System.EventArgs e)
		{
			this.LayoutMdi ( MdiLayout.Cascade );
		}

		private void barItem2_Click(object sender, System.EventArgs e)
		{
			this.LayoutMdi ( MdiLayout.TileHorizontal ) ;
		}

		private void barItem3_Click(object sender, System.EventArgs e)
		{
			this.LayoutMdi ( MdiLayout.TileVertical ) ;
		}




	}
}
