Imports Microsoft.VisualBasic
Imports System
Imports System.IO
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Text.RegularExpressions

Imports Syncfusion.XlsIO
Imports Syncfusion.Windows.Forms
Imports Syncfusion.GridExcelConverter
Imports Syncfusion.Windows.Forms.Grid

Namespace _41388
	''' <summary>
	''' Summary description for Edit.
	''' </summary>
	Public Class EditExcel : Inherits System.Windows.Forms.Form
		Private mainFrameBarManager As Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager
		Private mainMenu As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private fileParentBarItem As Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem
		Private newParentBarItem As Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem
		Private standardToolBar As Syncfusion.Windows.Forms.Tools.XPMenus.Bar
		Private WithEvents openBarItem As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents saveBarItem As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Friend WithEvents workSheetBarItem As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents workBookBarItem As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private components As System.ComponentModel.IContainer
		Private WithEvents exitBarItem As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private statusBar1 As System.Windows.Forms.StatusBar
		Private statusBarPanel1 As System.Windows.Forms.StatusBarPanel
		Private dateSBPanel As System.Windows.Forms.StatusBarPanel
		Private timeSBPanel As System.Windows.Forms.StatusBarPanel

		Private childWorkBookNumber As Integer = 0
		Private imageList As System.Windows.Forms.ImageList
		Private panel1 As System.Windows.Forms.Panel
		Public tvwCode As System.Windows.Forms.TreeView
		Private splitter1 As System.Windows.Forms.Splitter
		Private WithEvents barItem1 As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItem2 As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private WithEvents barItem3 As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Private barItem4 As Syncfusion.Windows.Forms.Tools.XPMenus.BarItem
		Friend workBook As WorkBook = Nothing
		Public Sub New()
			'
			' Required for Windows Form Designer support
			'
			InitializeComponent()

			'
			' TODO: Add any constructor code after InitializeComponent call
			'
			Dim timer As Timer = New Timer()
			timer.Enabled = True
			timer.Interval = 100
			AddHandler timer.Tick, AddressOf timer_Tick
			Me.WindowState = FormWindowState.Maximized
		End Sub

		''' <summary>
		''' Clean up any resources being used.
		''' </summary>
		Protected Overrides Overloads Sub Dispose(ByVal disposing As Boolean)
			If disposing Then
				If Not components Is Nothing Then
					components.Dispose()
				End If
			End If
			MyBase.Dispose(disposing)
		End Sub

		#Region "Windows Form Designer generated code"
		''' <summary>
		''' Required method for Designer support - do not modify
		''' the contents of this method with the code editor.
		''' </summary>
		Private Sub InitializeComponent()
			Me.components = New System.ComponentModel.Container()
			Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(EditExcel))
			Me.mainFrameBarManager = New Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(Me.components, Me)
			Me.mainMenu = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.mainFrameBarManager, "MainMenu")
			Me.fileParentBarItem = New Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem()
			Me.newParentBarItem = New Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem()
			Me.workBookBarItem = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.workSheetBarItem = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.openBarItem = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.saveBarItem = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.exitBarItem = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.standardToolBar = New Syncfusion.Windows.Forms.Tools.XPMenus.Bar(Me.mainFrameBarManager, "StandardToolBar")
			Me.imageList = New System.Windows.Forms.ImageList(Me.components)
			Me.statusBar1 = New System.Windows.Forms.StatusBar()
			Me.statusBarPanel1 = New System.Windows.Forms.StatusBarPanel()
			Me.dateSBPanel = New System.Windows.Forms.StatusBarPanel()
			Me.timeSBPanel = New System.Windows.Forms.StatusBarPanel()
			Me.panel1 = New System.Windows.Forms.Panel()
			Me.tvwCode = New System.Windows.Forms.TreeView()
			Me.splitter1 = New System.Windows.Forms.Splitter()
			Me.barItem1 = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.barItem2 = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.barItem3 = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			Me.barItem4 = New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem()
			CType(Me.mainFrameBarManager, System.ComponentModel.ISupportInitialize).BeginInit()
			CType(Me.statusBarPanel1, System.ComponentModel.ISupportInitialize).BeginInit()
			CType(Me.dateSBPanel, System.ComponentModel.ISupportInitialize).BeginInit()
			CType(Me.timeSBPanel, System.ComponentModel.ISupportInitialize).BeginInit()
			Me.panel1.SuspendLayout()
			Me.SuspendLayout()
			' 
			' mainFrameBarManager
			' 
			Me.mainFrameBarManager.BarPositionInfo = (CType(resources.GetObject("mainFrameBarManager.BarPositionInfo"), System.IO.MemoryStream))
			Me.mainFrameBarManager.Bars.Add(Me.mainMenu)
			Me.mainFrameBarManager.Bars.Add(Me.standardToolBar)
			Me.mainFrameBarManager.Categories.Add("windows")
			Me.mainFrameBarManager.Categories.Add("File")
			Me.mainFrameBarManager.CurrentBaseFormType = ""
			Me.mainFrameBarManager.Form = Me
			Me.mainFrameBarManager.ImageList = Me.imageList
			Me.mainFrameBarManager.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.fileParentBarItem, Me.newParentBarItem, Me.openBarItem, Me.saveBarItem, Me.workSheetBarItem, Me.workBookBarItem, Me.exitBarItem, Me.barItem1, Me.barItem2, Me.barItem3, Me.barItem4})
			Me.mainFrameBarManager.LargeImageList = Nothing
			Me.mainFrameBarManager.ResetCustomization = False
			' 
			' mainMenu
			' 
			Me.mainMenu.AllowHiding = False
			Me.mainMenu.BarName = "MainMenu"
			Me.mainMenu.BarStyle = (CType(((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsMainMenu Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder), Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle))
			Me.mainMenu.Caption = "MainMenu"
			Me.mainMenu.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.fileParentBarItem})
			Me.mainMenu.Manager = Me.mainFrameBarManager
			' 
			' fileParentBarItem
			' 
			Me.fileParentBarItem.CategoryIndex = 1
			Me.fileParentBarItem.ID = "File"
			Me.fileParentBarItem.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.newParentBarItem, Me.openBarItem, Me.saveBarItem, Me.exitBarItem})
			Me.fileParentBarItem.Text = "File"
			' 
			' newParentBarItem
			' 
			Me.newParentBarItem.CategoryIndex = 1
			Me.newParentBarItem.ID = "New"
			Me.newParentBarItem.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.workBookBarItem, Me.workSheetBarItem})
			Me.newParentBarItem.Style = Syncfusion.Windows.Forms.VisualStyle.OfficeXP
			Me.newParentBarItem.Text = "New"
			' 
			' workBookBarItem
			' 
			Me.workBookBarItem.CategoryIndex = 1
			Me.workBookBarItem.ID = "WorkBook"
			Me.workBookBarItem.Text = "WorkBook"
'			Me.workBookBarItem.Click += New System.EventHandler(Me.workBookBarItem_Click);
			' 
			' workSheetBarItem
			' 
			Me.workSheetBarItem.CategoryIndex = 1
			Me.workSheetBarItem.Enabled = False
			Me.workSheetBarItem.ID = "WorkSheet"
			Me.workSheetBarItem.ImageIndex = 0
			Me.workSheetBarItem.Text = "WorkSheet"
'			Me.workSheetBarItem.Click += New System.EventHandler(Me.workSheetBarItem_Click);
			' 
			' openBarItem
			' 
			Me.openBarItem.CategoryIndex = 1
			Me.openBarItem.ID = "open"
			Me.openBarItem.ImageIndex = 1
			Me.openBarItem.Text = "Open"
'			Me.openBarItem.Click += New System.EventHandler(Me.openBarItem_Click);
			' 
			' saveBarItem
			' 
			Me.saveBarItem.CategoryIndex = 1
			Me.saveBarItem.ID = "Save"
			Me.saveBarItem.ImageIndex = 2
			Me.saveBarItem.Text = "Save"
'			Me.saveBarItem.Click += New System.EventHandler(Me.saveBarItem_Click);
			' 
			' exitBarItem
			' 
			Me.exitBarItem.CategoryIndex = 1
			Me.exitBarItem.ID = "Exit"
			Me.exitBarItem.Text = "Exit"
'			Me.exitBarItem.Click += New System.EventHandler(Me.exitBarItem_Click);
			' 
			' standardToolBar
			' 
			Me.standardToolBar.BarName = "StandardToolBar"
			Me.standardToolBar.BarStyle = (CType((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.RotateWhenVertical) Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) Or Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder), Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle))
			Me.standardToolBar.Caption = "StandardToolBar"
			Me.standardToolBar.Items.AddRange(New Syncfusion.Windows.Forms.Tools.XPMenus.BarItem() { Me.workSheetBarItem, Me.openBarItem, Me.saveBarItem})
			Me.standardToolBar.Manager = Me.mainFrameBarManager
			' 
			' imageList
			' 
			Me.imageList.ImageSize = New System.Drawing.Size(16, 16)
			Me.imageList.ImageStream = (CType(resources.GetObject("imageList.ImageStream"), System.Windows.Forms.ImageListStreamer))
			Me.imageList.TransparentColor = System.Drawing.Color.Cyan
			' 
			' statusBar1
			' 
			Me.statusBar1.Location = New System.Drawing.Point(0, 490)
			Me.statusBar1.Name = "statusBar1"
			Me.statusBar1.Panels.AddRange(New System.Windows.Forms.StatusBarPanel() { Me.statusBarPanel1, Me.dateSBPanel, Me.timeSBPanel})
			Me.statusBar1.ShowPanels = True
			Me.statusBar1.Size = New System.Drawing.Size(988, 24)
			Me.statusBar1.TabIndex = 5
			Me.statusBar1.Text = "statusBar1"
			' 
			' statusBarPanel1
			' 
			Me.statusBarPanel1.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring
			Me.statusBarPanel1.Width = 952
			' 
			' dateSBPanel
			' 
			Me.dateSBPanel.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents
			Me.dateSBPanel.Width = 10
			' 
			' timeSBPanel
			' 
			Me.timeSBPanel.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents
			Me.timeSBPanel.Width = 10
			' 
			' panel1
			' 
			Me.panel1.Controls.Add(Me.tvwCode)
			Me.panel1.Dock = System.Windows.Forms.DockStyle.Left
			Me.panel1.Location = New System.Drawing.Point(0, 51)
			Me.panel1.Name = "panel1"
			Me.panel1.Size = New System.Drawing.Size(112, 439)
			Me.panel1.TabIndex = 7
			' 
			' tvwCode
			' 
			Me.tvwCode.Dock = System.Windows.Forms.DockStyle.Fill
			Me.tvwCode.ImageIndex = -1
			Me.tvwCode.Location = New System.Drawing.Point(0, 0)
			Me.tvwCode.Name = "tvwCode"
			Me.tvwCode.SelectedImageIndex = -1
			Me.tvwCode.Size = New System.Drawing.Size(112, 439)
			Me.tvwCode.TabIndex = 0
			' 
			' splitter1
			' 
			Me.splitter1.Location = New System.Drawing.Point(112, 51)
			Me.splitter1.Name = "splitter1"
			Me.splitter1.Size = New System.Drawing.Size(6, 439)
			Me.splitter1.TabIndex = 8
			Me.splitter1.TabStop = False
			' 
			' barItem1
			' 
			Me.barItem1.CategoryIndex = 0
			Me.barItem1.ID = "Cascade"
			Me.barItem1.Text = "Cascade"
'			Me.barItem1.Click += New System.EventHandler(Me.barItem1_Click);
			' 
			' barItem2
			' 
			Me.barItem2.CategoryIndex = 0
			Me.barItem2.ID = "Horizontal"
			Me.barItem2.Text = "Horizontal"
'			Me.barItem2.Click += New System.EventHandler(Me.barItem2_Click);
			' 
			' barItem3
			' 
			Me.barItem3.CategoryIndex = 0
			Me.barItem3.ID = "Vertical"
			Me.barItem3.Text = "Vertical"
'			Me.barItem3.Click += New System.EventHandler(Me.barItem3_Click);
			' 
			' barItem4
			' 
			Me.barItem4.CategoryIndex = 1
			Me.barItem4.ID = "Cascade_1"
			Me.barItem4.Text = "Cascade"
			' 
			' EditExcel
			' 
			Me.AutoScaleBaseSize = New System.Drawing.Size(6, 14)
			Me.ClientSize = New System.Drawing.Size(988, 514)
			Me.Controls.Add(Me.splitter1)
			Me.Controls.Add(Me.panel1)
			Me.Controls.Add(Me.statusBar1)
			Me.Icon = (CType(resources.GetObject("$this.Icon"), System.Drawing.Icon))
			Me.IsMdiContainer = True
			Me.Name = "EditExcel"
			Me.Text = "EditExcel"
'			Me.Load += New System.EventHandler(Me.EditExcel_Load);
			CType(Me.mainFrameBarManager, System.ComponentModel.ISupportInitialize).EndInit()
			CType(Me.statusBarPanel1, System.ComponentModel.ISupportInitialize).EndInit()
			CType(Me.dateSBPanel, System.ComponentModel.ISupportInitialize).EndInit()
			CType(Me.timeSBPanel, System.ComponentModel.ISupportInitialize).EndInit()
			Me.panel1.ResumeLayout(False)
			Me.ResumeLayout(False)

		End Sub
		#End Region



		Private Sub timer_Tick(ByVal sender As Object, ByVal e As EventArgs)
			Dim dt As DateTime = DateTime.Now
			Me.timeSBPanel.Text = dt.ToShortTimeString()
			Me.dateSBPanel.Text = dt.ToLongDateString()
		End Sub


		Private Sub workBookBarItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles workBookBarItem.Click
			Dim workBook As WorkBook = New WorkBook()
			workBook.MdiParent = Me
            workBook.Text = "WorkBook" + CType((childWorkBookNumber + 1),String) 
			workBook.Show()
		End Sub

		Private Sub workSheetBarItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles workSheetBarItem.Click
			Me.workBook.insertSheetMenuItem.PerformClick()
		End Sub


		Private Sub saveBarItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles saveBarItem.Click
			If Not Me.workBook Is Nothing Then
				Dim saveFileDialog As SaveFileDialog = New SaveFileDialog()
				saveFileDialog.Filter = "Files(*.GXL;*.XLS)|*.GXL;*.XLS"
				saveFileDialog.AddExtension = True
				saveFileDialog.DefaultExt = ".GXL"
				saveFileDialog.FileName = Me.workBook.Text

				If saveFileDialog.ShowDialog() = DialogResult.OK AndAlso saveFileDialog.CheckPathExists Then
					Dim path As String = System.IO.Path.GetDirectoryName(saveFileDialog.FileName)

                    Me.workBook._grid.CurrentCell.EndEdit()

                    If saveFileDialog.FileName.ToUpper().EndsWith(".GXL") Then
                        Dim stream As FileStream = New FileStream(saveFileDialog.FileName, FileMode.Create)
                        Dim bWriter As BinaryWriter = New BinaryWriter(stream, System.Text.Encoding.BigEndianUnicode)
                        bWriter.Write(Me.workBook.tabBarSplitterControl.TabBarPages.Count)
                        Dim i As Integer
                        i = 0
                        'ORIGINAL LINE: for(i =0;i<Me.workBook.tabBarSplitterControl.TabBarPages.Count;i += 1)
                        'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
                        Do While i < Me.workBook.tabBarSplitterControl.TabBarPages.Count
                            Dim page As TabBarPage = Me.workBook.tabBarSplitterControl.TabBarPages(i)
                            Dim _grid As GridControl = Nothing
                            If Not page.Controls(0) Is Nothing AndAlso TypeOf page.Controls(0) Is GridControl Then
                                _grid = CType(IIf(TypeOf page.Controls(0) Is GridControl, page.Controls(0), Nothing), GridControl)
                            Else
                                _grid = CType(IIf(TypeOf Me.workBook.tabBarSplitterControl.ActivePane Is GridControl, Me.workBook.tabBarSplitterControl.ActivePane, Nothing), GridControl)
                            End If

                            Dim fileName As String = path + String.Format("\{0}{1}.grd", System.IO.Path.GetFileNameWithoutExtension(saveFileDialog.FileName), i)
                            _grid.Model.SaveBinary(fileName)
                            bWriter.Write(page.Text)

                            i += 1
                        Loop
                        bWriter.Close()
                        stream.Close()
                    End If

                Else
                    If saveFileDialog.FileName.ToUpper().EndsWith(".XLS") Then
                        Dim workBook As IWorkbook = ExcelUtils.CreateWorkbook(Me.workBook.tabBarSplitterControl.TabBarPages.Count)
                        Dim gecc As GridExcelConverterControl = New GridExcelConverterControl

                        Dim i As Integer = 0
                        'ORIGINAL LINE: for(int i =0;i<Me.workBook.tabBarSplitterControl.TabBarPages.Count;i += 1)
                        'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
                        Do While i < Me.workBook.tabBarSplitterControl.TabBarPages.Count
                            Dim page As TabBarPage = Me.workBook.tabBarSplitterControl.TabBarPages(i)

                            Dim _grid As GridControl = Nothing
                            If Not page.Controls(0) Is Nothing AndAlso TypeOf page.Controls(0) Is GridControl Then
                                _grid = CType(IIf(TypeOf page.Controls(0) Is GridControl, page.Controls(0), Nothing), GridControl)
                            Else
                                _grid = CType(IIf(TypeOf Me.workBook.tabBarSplitterControl.ActivePane Is GridControl, Me.workBook.tabBarSplitterControl.ActivePane, Nothing), GridControl)
                            End If

                            Dim workSheet As IWorksheet = workBook.Worksheets(i)
                            gecc.GridToExcel(_grid.Model, workSheet)

                            i += 1
                        Loop

                        workBook.SaveAs(saveFileDialog.FileName)
                        workBook.Close()
                        ExcelUtils.ThrowNotSavedOnDestroy = False

                    End If
                End If

                Me.workBook.Text = path.GetFileNameWithoutExtension(saveFileDialog.FileName)
            End If
            'End If
		End Sub

		Public Sub DELEt(ByVal node As TreeNode)

			Dim i As Integer =0
'ORIGINAL LINE: for(int i =0;i<node.Nodes.Count;i += 1)
'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
			Do While i<node.Nodes.Count
				Dim Tnode As TreeNode = New TreeNode()
				Tnode = node.Nodes(i)
				If node.Nodes.Count<>0 Then
					DELEt(Tnode)
				Else
					Tnode.Remove()
					i -= 1
				End If

				i += 1
			Loop
		End Sub

		'public void GetRoot()
		'{
			'TreeNode Root = tvwCode.Nodes[0];
			'DELEt(Root);

		'}


		Public Sub DelNodeText(ByVal tncnode As TreeNodeCollection)
			For Each node As TreeNode In tncnode
				If node.Nodes.Count<>0 Then
					DelNodeText(node.Nodes)
				Else
					'  MessageBox.Show("֦ӽڵ㣬ɾ");

					node.Remove()
					Return
				End If
			Next node
		End Sub

		Friend Sub FindNodeText(ByVal tnc As TreeNodeCollection, ByVal filenamee As String)
			For Each node As TreeNode In tnc
				If node.Nodes.Count<>0 Then
					FindNodeText(node.Nodes,filenamee)
				End If
				If node.Text=filenamee Then
					'  MessageBox.Show("Ϸļ");

					DELEt(node)
					'DelNodeText(node.Nodes);
					'return;
				End If
			Next node
		End Sub


		Private openy As Boolean=False
		Public Sub GetAllNodeText(ByVal tnc As TreeNodeCollection, ByVal filenamee As String)
			For Each node As TreeNode In tnc
				If node.Nodes.Count<>0 Then
					GetAllNodeText(node.Nodes,filenamee)
				End If
				If node.Text=filenamee Then
					'  MessageBox.Show("ļѾ򿪣罨½ť1111");
					openy=True
					Return
				End If
			Next node
		End Sub

        Private Sub openBarItem_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            Dim openFileDialog As OpenFileDialog = New OpenFileDialog
            openFileDialog.Filter = "Files(*.GXL;*.XLS)|*.GXL;*.XLS"
            If openFileDialog.ShowDialog() = DialogResult.OK Then
                Dim path As String = System.IO.Path.GetDirectoryName(openFileDialog.FileName)

                'жǷļ
                If tvwCode.Nodes.Count > 0 Then
                    GetAllNodeText(tvwCode.Nodes, openFileDialog.FileName)
                    If openy = True Then
                        MessageBox.Show("ļѾ򿪣罨½ť")
                        openy = False
                        GoTo Endf
                        ' should be quit?
                        'TODO: INSTANT VB TODO TASK: The following line could not be converted:
                    End If
                    ' жϽ

                    If openFileDialog.CheckFileExists Then
                        Dim workBook As workBook = New workBook
                        workBook.MdiParent = Me
                        'TODO: INSTANT VB TODO TASK: Assignments within expressions are not supported in VB.NET
                        'ORIGINAL LINE: workBook.Tag = childWorkBookNumber += 1;
                        workBook.Tag = childWorkBookNumber + 1
                        workBook.Show()
                        Me.workBook = workBook

                        For x As Integer = Me.workBook.tabBarSplitterControl.TabBarPages.Count - 1 To 0 Step -1
                            If Me.workBook.tabBarSplitterControl.ActivePage.Text <> Me.workBook.tabBarSplitterControl.TabBarPages(x).Text Then
                                Me.workBook.tabBarSplitterControl.TabBarPages(x).Dispose()
                            End If
                        Next x


                        If openFileDialog.FileName.ToUpper().EndsWith(".GXL") Then
                            Dim stream As FileStream = New FileStream(openFileDialog.FileName, FileMode.Open)
                            Dim bReader As BinaryReader = New BinaryReader(stream, System.Text.Encoding.BigEndianUnicode)
                            'int temp = 0;
                            Dim pageInfo As ArrayList = New ArrayList
                            Dim sheetCount As Integer = bReader.ReadInt32()

                            Dim l As Integer = 0
                            'ORIGINAL LINE: for(int l = 0;l<sheetCount;l += 1)
                            'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
                            Do While l < sheetCount
                                Dim tabBarPage As TabBarPage = New TabBarPage(bReader.ReadString())

                                Dim GRID As GridControl = New GridControl
                                GRID.ContextMenu = Me.workBook.gridContextMenu
                                GRID.FloatCellsMode = GridFloatCellsMode.BeforeDisplayCalculation
                                tabBarPage.Controls.Add(GRID)
                                Me.workBook.tabBarSplitterControl.TabBarPages.Add(tabBarPage)
                                Dim fileName As String = path + String.Format("\{0}{1}.grd", System.IO.Path.GetFileNameWithoutExtension(openFileDialog.FileName), l)
                                GRID.Model = GridModel.LoadBinary(fileName)
                                Me.workBook.PopulateGrid(GRID) '//ʽgridʽ

                                l += 1
                            Loop
                            Me.workBook.RegisterGrid()
                            bReader.Close()
                            stream.Close()
                        End If

                    Else
                        If openFileDialog.FileName.ToUpper().EndsWith(".XLS") Then


                            Dim excelEngine As excelEngine = New excelEngine
                            Dim application As IApplication = excelEngine.Excel
                            'INSTANT VB NOTE: The local variable workbook was renamed since Visual Basic will not uniquely identify local variables when other local variables have the same name:
                            Dim workbook_Renamed As IWorkbook = excelEngine.Excel.Workbooks.Open(openFileDialog.FileName)

                            Dim j As Integer = 0
                            Dim gecc As GridExcelConverterControl = New GridExcelConverterControl
                            j = 0
                            'ORIGINAL LINE: for(j = 0;j<workbook.Worksheets.Count;j += 1)
                            'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
                            Do While j < workbook_Renamed.Worksheets.Count
                                Dim workSheet As IWorksheet = workbook_Renamed.Worksheets(j)

                                Dim tabBarPage As TabBarPage = New Syncfusion.Windows.Forms.TabBarPage(workSheet.Name)
                                tabBarPage.Text = workSheet.Name
                                Dim GRID As GridControl = New GridControl

                                GRID.RowCount = workSheet.UsedRange.End.Row
                                GRID.ColCount = workSheet.UsedRange.End.Column
                                GRID.TableStyle.CellType = "FormulaCell"
                                GRID.FloatCellsMode = GridFloatCellsMode.BeforeDisplayCalculation
                                tabBarPage.Controls.Add(GRID)
                                Me.workBook.tabBarSplitterControl.TabBarPages.Add(tabBarPage)

                                For r As Integer = 1 To workSheet.UsedRange.End.Row
                                    For c As Integer = 1 To workSheet.UsedRange.End.Column
                                        If workSheet.Range(r, c).HasFormula = True Then
                                            If Regex.Match(workSheet.Range(r, c).Text, "'").Success Then
                                                workSheet.Range(r, c).Text = Regex.Replace(workSheet.Range(r, c).Text, "'", "")
                                            End If
                                        End If
                                    Next c
                                Next r




                                If workSheet.UsedRange.End.Row > 0 AndAlso workSheet.UsedRange.End.Column > 0 Then
                                    gecc.ExcelToGrid(workSheet, GRID.Model)
                                    Me.workBook.RegisterGrid()
                                    Dim engine As GridFormulaEngine
                                    engine = (CType(GRID.CellModels("FormulaCell"), GridFormulaCellModel)).Engine
                                    engine.RecalculateRange(GridRangeInfo.Table(), True)

                                End If
                                GRID.RowCount = 1000
                                GRID.ColCount = 1000
                                Me.workBook.PopulateGrid(GRID) 'ʽgridʽ


                                j += 1
                            Loop

                            workbook_Renamed.Close()
                            excelEngine.ThrowNotSavedOnDestroy = False
                            excelEngine.Dispose()
                            Me.workBook.tabBarSplitterControl.ActivePage = Me.workBook.tabBarSplitterControl.TabBarPages(0)
                            Me.workBook.tabBarSplitterControl.Refresh()

                        End If
                    End If

                    Me.workBook.tabBarSplitterControl.ActivateNextPage(True)
                    Me.workBook.tabBarSplitterControl.TabBarPages(0).Dispose()
                    Me.workBook.Text = System.IO.Path.GetFileNameWithoutExtension(openFileDialog.FileName)

                End If

                '/////----------/treeview

                Dim lastindex As Integer = tvwCode.Nodes.Count
                If lastindex < 1 Then
                    ' tvwCode.Nodes.Clear();
                    Dim Mynode As TreeNode = New TreeNode("ʲϸ")
                    tvwCode.Nodes.Add(Mynode) 'һڵ
                    Mynode.ImageIndex = 0
                    Mynode.SelectedImageIndex = 0

                Else
                    Dim Mynode As TreeNode = tvwCode.Nodes(0)
                End If

                Dim Mynodef As TreeNode = New TreeNode(openFileDialog.FileName)
                tvwCode.TopNode.Nodes.Add(Mynodef)
                Mynodef.ImageIndex = 1
                Mynodef.SelectedImageIndex = 2
                '  Document.tabBarSplitterControl1.TabBarPages[0].;

                Dim i As Integer = 0
                'ORIGINAL LINE: for (int i = 0; i <Me.workBook.tabBarSplitterControl.TabBarPages.Count; i += 1)
                'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
                Do While i < Me.workBook.tabBarSplitterControl.TabBarPages.Count
                    Dim nodename As String = Me.workBook.tabBarSplitterControl.TabBarPages(i).Text
                    Dim MyNodec As TreeNode = New TreeNode(nodename)
                    If nodename.IndexOf("_") > 0 Then '(pos("_"c,nodename)>0)
                        Dim huiexist As Boolean = False

                        Dim ii As Integer
                        ii = lastindex
                        'ORIGINAL LINE: for (ii=lastindex; ii<tvwCode.Nodes.Count; ii += 1)
                        'INSTANT VB NOTE: This 'for' loop was translated to a VB 'Do While' loop:
                        Do While ii < tvwCode.Nodes.Count
                            If tvwCode.Nodes(ii).Text.IndexOf(nodename.Substring(1, nodename.IndexOf("_")) + "") > 0 Then
                                tvwCode.Nodes(ii).Nodes.Add(MyNodec)
                                MyNodec.ImageIndex = 1
                                MyNodec.SelectedImageIndex = 2
                                huiexist = True
                                Exit Do
                            End If
                            ii += 1
                        Loop

                        If huiexist = False Then
                            tvwCode.Nodes(ii).Nodes.Add(MyNodec)
                            MyNodec.ImageIndex = 1
                            MyNodec.SelectedImageIndex = 2
                        End If

                    Else
                        Mynodef.Nodes.Add(MyNodec)
                        MyNodec.ImageIndex = 1
                        MyNodec.SelectedImageIndex = 2
                    End If
                    i += 1
                Loop
                tvwCode.TopNode.Expand() '׽ڵչ
                Mynodef.Expand() '׽ڵչ
                'Screen.Cursor=crDefault;

                '///////--------------treeview

                End
            End If

Endf:
        End Sub

        Private Sub exitBarItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles exitBarItem.Click
            Me.Close()
        End Sub





        Private Sub barItem1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItem1.Click
            Me.LayoutMdi(MdiLayout.Cascade)
        End Sub

        Private Sub barItem2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItem2.Click
            Me.LayoutMdi(MdiLayout.TileHorizontal)
        End Sub

        Private Sub barItem3_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles barItem3.Click
            Me.LayoutMdi(MdiLayout.TileVertical)
        End Sub

        Private Sub EditExcel_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
            Me.workBookBarItem.PerformClick()
        End Sub
    End Class
End Namespace
