using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;

using Syncfusion.XlsIO;
using Syncfusion.Windows.Forms;
using Syncfusion.GridExcelConverter;
using Syncfusion.Windows.Forms.Grid;
using ExcelMarker;
using _41388;

namespace _41388
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class WorkBook : System.Windows.Forms.Form
	{

		//private ExcelMarkerMouseController excelMarker = null;
		internal Syncfusion.Windows.Forms.TabBarSplitterControl tabBarSplitterControl;
		private System.Windows.Forms.ContextMenu tBSCContextMenu;
		internal System.Windows.Forms.MenuItem insertSheetMenuItem;
		internal System.Windows.Forms.MenuItem deleteSheetMenuItem;	
		internal Syncfusion.Windows.Forms.Grid.GridAwareTextBox gridAwareTextBox;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem insertRowBarItem;
		private System.ComponentModel.IContainer components = null;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Grid.GridAwareTextBox gridAwareTextBox1;
		internal System.Windows.Forms.ContextMenu gridContextMenu;
		internal System.Windows.Forms.MenuItem cutMenuItem;
		internal System.Windows.Forms.MenuItem copyMenuItem;
		internal System.Windows.Forms.MenuItem pasteMenuItem;
		internal System.Windows.Forms.MenuItem deleteMenuItem;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem renameSheetMenuItem;
		ListSortDirection dir;
		public WorkBook()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(WorkBook));
			this.tabBarSplitterControl = new Syncfusion.Windows.Forms.TabBarSplitterControl();
			this.gridAwareTextBox = new Syncfusion.Windows.Forms.Grid.GridAwareTextBox();
			this.tBSCContextMenu = new System.Windows.Forms.ContextMenu();
			this.insertSheetMenuItem = new System.Windows.Forms.MenuItem();
			this.deleteSheetMenuItem = new System.Windows.Forms.MenuItem();
			this.parentBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.insertRowBarItem = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.panel1 = new System.Windows.Forms.Panel();
			this.gridAwareTextBox1 = new Syncfusion.Windows.Forms.Grid.GridAwareTextBox();
			this.gridContextMenu = new System.Windows.Forms.ContextMenu();
			this.cutMenuItem = new System.Windows.Forms.MenuItem();
			this.copyMenuItem = new System.Windows.Forms.MenuItem();
			this.pasteMenuItem = new System.Windows.Forms.MenuItem();
			this.deleteMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.renameSheetMenuItem = new System.Windows.Forms.MenuItem();
			this.tabBarSplitterControl.SuspendLayout();
			this.panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabBarSplitterControl
			// 
			this.tabBarSplitterControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.tabBarSplitterControl.Controls.Add(this.gridAwareTextBox);
			this.tabBarSplitterControl.EnabledColor = System.Drawing.SystemColors.WindowText;
			this.tabBarSplitterControl.Location = new System.Drawing.Point(0, 37);
			this.tabBarSplitterControl.Name = "tabBarSplitterControl";
			this.tabBarSplitterControl.Size = new System.Drawing.Size(780, 468);
			this.tabBarSplitterControl.SplitBars = Syncfusion.Windows.Forms.DynamicSplitBars.Both;
			this.tabBarSplitterControl.TabIndex = 0;
			this.tabBarSplitterControl.Text = "tabBarSplitterControl1";
			this.tabBarSplitterControl.ThemesEnabled = true;
			this.tabBarSplitterControl.PaneClosing += new Syncfusion.Windows.Forms.SplitterPaneEventHandler(this.tabBarSplitterControl_PaneClosing);
			this.tabBarSplitterControl.ActivePageChanging += new System.Windows.Forms.ControlEventHandler(this.tabBarSplitterControl_ActivePageChanging);
			this.tabBarSplitterControl.PaneCreated += new Syncfusion.Windows.Forms.SplitterPaneEventHandler(this.tabBarSplitterControl_PaneCreated);
			// 
			// gridAwareTextBox
			// 
			this.gridAwareTextBox.DisabledBackColor = System.Drawing.SystemColors.Window;
			this.gridAwareTextBox.EnabledBackColor = System.Drawing.SystemColors.Window;
			this.gridAwareTextBox.Location = new System.Drawing.Point(-100, -100);
			this.gridAwareTextBox.Name = "gridAwareTextBox";
			this.gridAwareTextBox.TabIndex = 1;
			// 
			// tBSCContextMenu
			// 
			this.tBSCContextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							this.insertSheetMenuItem,
																							this.deleteSheetMenuItem,
																							this.menuItem1,
																							this.renameSheetMenuItem});
			// 
			// insertSheetMenuItem
			// 
			this.insertSheetMenuItem.Index = 0;
			this.insertSheetMenuItem.Text = "Insert Sheet...";
			this.insertSheetMenuItem.Click += new System.EventHandler(this.insertSheetMenuItem_Click);
			// 
			// deleteSheetMenuItem
			// 
			this.deleteSheetMenuItem.Index = 1;
			this.deleteSheetMenuItem.Text = "Delete Sheet...";
			this.deleteSheetMenuItem.Click += new System.EventHandler(this.deleteSheetMenuItem_Click);
			// 
			// parentBarItem
			// 
			this.parentBarItem.CategoryIndex = -1;
			this.parentBarItem.ID = "";
			this.parentBarItem.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																									   this.insertRowBarItem});
			// 
			// insertRowBarItem
			// 
			this.insertRowBarItem.CategoryIndex = -1;
			this.insertRowBarItem.ID = "insertRowBarItem";
			this.insertRowBarItem.Text = "Insert Row";
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.gridAwareTextBox1);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(775, 30);
			this.panel1.TabIndex = 2;
			// 
			// gridAwareTextBox1
			// 
			this.gridAwareTextBox1.DisabledBackColor = System.Drawing.SystemColors.Window;
			this.gridAwareTextBox1.EnabledBackColor = System.Drawing.SystemColors.Window;
			this.gridAwareTextBox1.Location = new System.Drawing.Point(20, 6);
			this.gridAwareTextBox1.Name = "gridAwareTextBox1";
			this.gridAwareTextBox1.Size = new System.Drawing.Size(660, 20);
			this.gridAwareTextBox1.TabIndex = 2;
			// 
			// gridContextMenu
			// 
			this.gridContextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							this.cutMenuItem,
																							this.copyMenuItem,
																							this.pasteMenuItem,
																							this.deleteMenuItem});
			// 
			// cutMenuItem
			// 
			this.cutMenuItem.Index = 0;
			this.cutMenuItem.Text = "Cut";
			this.cutMenuItem.Click += new System.EventHandler(this.cutMenuItem_Click);
			// 
			// copyMenuItem
			// 
			this.copyMenuItem.Index = 1;
			this.copyMenuItem.Text = "Copy";
			this.copyMenuItem.Click += new System.EventHandler(this.copyMenuItem_Click);
			// 
			// pasteMenuItem
			// 
			this.pasteMenuItem.Index = 2;
			this.pasteMenuItem.Text = "Paste";
			this.pasteMenuItem.Click += new System.EventHandler(this.pasteMenuItem_Click);
			// 
			// deleteMenuItem
			// 
			this.deleteMenuItem.Index = 3;
			this.deleteMenuItem.Text = "Delete";
			this.deleteMenuItem.Click += new System.EventHandler(this.deleteMenuItem_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 2;
			this.menuItem1.Text = "-";
			// 
			// renameSheetMenuItem
			// 
			this.renameSheetMenuItem.Index = 3;
			this.renameSheetMenuItem.Text = "Rename Sheet";
			this.renameSheetMenuItem.Click += new System.EventHandler(this.renameSheetMenuItem_Click);
			// 
			// WorkBook
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(775, 501);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.tabBarSplitterControl);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "WorkBook";
			this.Text = "WoorkBook";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			this.Closing += new System.ComponentModel.CancelEventHandler(this.WorkBook_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Activated += new System.EventHandler(this.WorkBook_Activated);
			this.Deactivate += new System.EventHandler(this.WorkBook_Deactivate);
			this.tabBarSplitterControl.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		internal ArrayList HiddenSheets = new ArrayList();
	
		private void MyInit()
		{

			this.tabBarSplitterControl.SuspendLayout();
			this.SuspendLayout();

			for(int i = 0; i<3;i++)
			{
				TabBarPage tabBarPage = new TabBarPage();
				GridControl _grid = new GridControl();
				// 
				// _grid
				// 
				_grid.Location = new System.Drawing.Point(0, 0);
				_grid.Name = string.Format("gridControl{0}",i+1);
				_grid.Dock = DockStyle.Fill;
				_grid.SmartSizeBox = false;
				_grid.Text = string.Format("gridControl{0}",i+1);
				_grid.RowCount = 100;
				_grid.ColCount = 100;
				_grid.ContextMenu = this.gridContextMenu;
				_grid.ThemesEnabled = true;


               PopulateGrid(_grid); ////ʽgridʽ
/*

				//һҼȡѡΧ
				_grid.SelectCellsMouseButtonsMask = ((System.Windows.Forms.MouseButtons)((System.Windows.Forms.MouseButtons.Left | System.Windows.Forms.MouseButtons.Middle)));


				this.gridAwareTextBox1.WireGrid(_grid);
				_grid.TableStyle.CellType = "FormulaCell";
				_grid.ExcelLikeCurrentCell = true;
				_grid.ExcelLikeSelectionFrame = true;
				_grid.ShouldSynchronizeCurrentCell = true;

				_grid.ControllerOptions = GridControllerOptions.All & (~GridControllerOptions.OleDataSource);
				_grid.MouseControllerDispatcher.Add(new ExcelMarkerMouseController(_grid));

				GridFormulaEngine engine = ((GridFormulaCellModel)_grid.CellModels["FormulaCell"]).Engine;
				engine.FormulaCopyFlags |= GridFormulaCopyFlags.ClipBoardReferencesAdjusted;


				_grid.EnterKeyBehavior = GridDirectionType.Down;
				_grid.TableStyle.CellType = "FormulaCell";
				//add the mousecontroller that handles formularange selections
				FormulaRangeSelectionController formulaController = new FormulaRangeSelectionController(_grid);
				_grid.MouseControllerDispatcher.Add(formulaController);
				///hjh///   gridControl1.Model.Options.DragDropDropTargetFlags = GridDragDropFlags.Text | GridDragDropFlags.Text;
				///hjh///   gridControl1.ControllerOptions = GridControllerOptions. All & (~GridControllerOptions.OleDataSource);
				engine.FormulaCopyFlags |= GridFormulaCopyFlags.InsDelRangeReferencesUpdated;
				engine.FormulaCopyFlags |= GridFormulaCopyFlags.ClipBoardReferencesAdjusted;

				//2˫Ž༭
				_grid.ActivateCurrentCellBehavior = GridCellActivateAction.DblClickOnCell;
				GridFormulaCellRenderer.ForceEditWhenActivated = false;
				_grid.Model.ColStyles[2].BackColor=Color.GreenYellow;
				_grid.Model.ColStyles[2].ReadOnly=true;

				_grid.ClipboardPaste += new Syncfusion.Windows.Forms.Grid.GridCutPasteEventHandler(_grid_ClipboardPaste);
				_grid.CellClick += new Syncfusion.Windows.Forms.Grid.GridCellClickEventHandler(_grid_CellClick);;
				_grid.KeyDown += new System.Windows.Forms.KeyEventHandler(_grid_KeyDown);
				_grid.QueryCellFormattedText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(_grid_QueryCellFormattedText);

*/



				// 
				// tabBarPage
				// 
				tabBarPage.Controls.Add(_grid);
				tabBarPage.Location = new System.Drawing.Point(0, 0);
				tabBarPage.Name = string.Format("tabBarPage{0}",i+1);
				tabBarPage.SplitBars = Syncfusion.Windows.Forms.DynamicSplitBars.Both;
				tabBarPage.Text = string.Format("Sheet{0}",i+1);
				tabBarPage.ThemesEnabled = true;
				this.tabBarSplitterControl.TabBarPages.Add(tabBarPage);



			}
			this.tabBarSplitterControl.ResumeLayout(true);
			this.ResumeLayout(true);

		}
		internal void PopulateGrid(GridControl _grid)
		{
			//һҼȡѡΧ
			_grid.SelectCellsMouseButtonsMask = ((System.Windows.Forms.MouseButtons)((System.Windows.Forms.MouseButtons.Left | System.Windows.Forms.MouseButtons.Middle)));


			this.gridAwareTextBox1.WireGrid(_grid);
			_grid.TableStyle.CellType = "FormulaCell";
			_grid.ExcelLikeCurrentCell = true;
			_grid.ExcelLikeSelectionFrame = true;
			_grid.ShouldSynchronizeCurrentCell = true;

			_grid.ControllerOptions = GridControllerOptions.All & (~GridControllerOptions.OleDataSource);
			_grid.MouseControllerDispatcher.Add(new ExcelMarkerMouseController(_grid));

			_grid.EnterKeyBehavior = GridDirectionType.Down;
			//add the mousecontroller that handles formularange selections
			FormulaRangeSelectionController formulaController = new FormulaRangeSelectionController(_grid);
			_grid.MouseControllerDispatcher.Add(formulaController);
			///hjh///   gridControl1.Model.Options.DragDropDropTargetFlags = GridDragDropFlags.Text | GridDragDropFlags.Text;
			///hjh///   gridControl1.ControllerOptions = GridControllerOptions. All & (~GridControllerOptions.OleDataSource);
			
			//2˫Ž༭
			_grid.ActivateCurrentCellBehavior = GridCellActivateAction.DblClickOnCell;
			GridFormulaCellRenderer.ForceEditWhenActivated = false;
			_grid.Model.ColStyles[2].BackColor=Color.GreenYellow;
			_grid.Model.ColStyles[2].ReadOnly=true;

			_grid.ClipboardPaste += new Syncfusion.Windows.Forms.Grid.GridCutPasteEventHandler(_grid_ClipboardPaste);
			_grid.CellClick += new Syncfusion.Windows.Forms.Grid.GridCellClickEventHandler(_grid_CellClick);;
			_grid.KeyDown += new System.Windows.Forms.KeyEventHandler(_grid_KeyDown);
			_grid.QueryCellFormattedText += new Syncfusion.Windows.Forms.Grid.GridCellTextEventHandler(_grid_QueryCellFormattedText);
			_grid.SaveCellInfo += new GridSaveCellInfoEventHandler(_grid_SaveCellInfo);


		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.MyInit();
			this.tabBarSplitterControl.Bar.ContextMenu = this.tBSCContextMenu;

		}
	
		internal GridControl _grid = null;
		private void tabBarSplitterControl_ActivePageChanging(object sender, System.Windows.Forms.ControlEventArgs e)
		{	
			if(e.Control != null)
				foreach(Control control in  e.Control.Controls)
				{
					if(control is GridControl)
					{
						_grid = control as GridControl;
						break;
					}
				}
			
		}


		private void tabBarSplitterControl_PaneCreated(object sender, Syncfusion.Windows.Forms.SplitterPaneEventArgs e)
		{
			_grid = (GridControl) e.Control;

			GridControlBase grid = (GridControlBase) e.Control;
			this.gridAwareTextBox1.WireGrid(grid);

			FormulaRangeSelectionController formulaController = new FormulaRangeSelectionController(grid);
			grid.MouseControllerDispatcher.Add(formulaController);

		
		}

		


		private void insertSheetMenuItem_Click(object sender, System.EventArgs e)
		{
			TabBarPage tabBarPage = new TabBarPage();
			GridControl _grid = new GridControl();
			int indx = this.tabBarSplitterControl.TabBarPages.IndexOf(this.tabBarSplitterControl.ActivePage);
			int oIndx = this.tabBarSplitterControl.TabBarPages.Count+1;
			// 
			// _grid
			// 
			_grid.Location = new System.Drawing.Point(0, 0);
			_grid.Name = string.Format("gridControl{0}",oIndx);
			_grid.SmartSizeBox = false;
			_grid.Text = string.Format("gridControl{0}",oIndx);
			_grid.RowCount = 100;
			_grid.ColCount = 100;
			_grid.ThemesEnabled = true;
			_grid.ContextMenu = this.gridContextMenu;
			_grid.TableStyle.CellType = "FormulaCell";

			// 
			// tabBarPage
			// 
			tabBarPage.Controls.Add(_grid);
			tabBarPage.Location = new System.Drawing.Point(0, 0);
			tabBarPage.Name = string.Format("tabBarPage{0}",oIndx);
			tabBarPage.SplitBars = Syncfusion.Windows.Forms.DynamicSplitBars.Both;
			tabBarPage.Text = string.Format("Sheet{0}",oIndx);
			tabBarPage.ThemesEnabled = true;
			this.PopulateGrid(_grid);
			
			GridFormulaEngine.RegisterGridAsSheet(string.Format("Sheet{0}",oIndx), _grid.Model, 1);
			this.tabBarSplitterControl.TabBarPages.Insert(indx,tabBarPage);
			
		}

		private void deleteSheetMenuItem_Click(object sender, System.EventArgs e)
		{
			if(this.tabBarSplitterControl.TabBarPages.Count>1)
			{
				TabBarPage page = this.tabBarSplitterControl.ActivePage;
				this.tabBarSplitterControl.ActivateNextPage(true);
				this.tabBarSplitterControl.TabBarPages.Remove(page);
			}
		}
	



	
			
	

		internal void RegisterGrid()
		{
			foreach(TabBarPage page in this.tabBarSplitterControl.TabBarPages)
			{
				GridControl grid=null;
				foreach(Control control in page.Controls)
					if(control is GridControl)
					{
						grid = control as GridControl;
						break;
					}
				if (grid!=null)
				{
					GridFormulaEngine.RegisterGridAsSheet(page.Text, grid.Model, 1);
					GridFormulaEngine engine = ((GridFormulaCellModel)grid.CellModels["FormulaCell"]).Engine;
					engine.FormulaCopyFlags |= GridFormulaCopyFlags.InsDelRangeReferencesUpdated;
					engine.FormulaCopyFlags |= GridFormulaCopyFlags.ClipBoardReferencesAdjusted;
				}
			}
			
		}

		private void tabBarSplitterControl_PaneClosing(object sender, Syncfusion.Windows.Forms.SplitterPaneEventArgs e)
		{
			GridControlBase grid = (GridControlBase) e.Control;
			this.gridAwareTextBox1.UnwireGrid(grid);

		}
		bool isPaste = false;
		private void _grid_ClipboardPaste(object sender, Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs e)
		{

			//Flag for ReferencesAdjusted Workaround....
			this.isPaste = true;

			// ѱģע͵, ʽճȷ

			  DataObject data = (DataObject)Clipboard.GetDataObject();
			  string[] rows = null;
			  int numRows = 0;
			  int numCols = 0;
			  //get the size of the paste
			  if(data.GetDataPresent(DataFormats.Text))
			  {
				  string s = (string)data.GetData(DataFormats.Text);
				  rows = s.Split(new char[]{'\n'});
			  numRows = rows.GetLength(0);
			  if(numRows > 0 && rows[numRows - 1].Length == 0)
				  numRows--; //remove extra empty row if present
			  if(numRows > 0)
			  {
				  string[] cols = rows[0].Split(new char[]{'\t'});
			  numCols = cols.GetLength(0);
				  }

				  }
			  //paste one to many
			  if(numRows == 1 && numCols == 1 && !_grid.Selections.Ranges.ActiveRange.IsEmpty)
			  {
				 _grid.ChangeCells(_grid.Selections.Ranges.ActiveRange,
					  rows[0]);
			    e.Handled =false;       //ע͵˾,ֻ11Ч, 1Զ໹Ч ,Ϊʲô?
				e.Result = true;
			  }
			 // /
		}
		

		private void _grid_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			//set the control key flag if control key is pressed.
			bool controlKeyDown = (e.Modifiers & Keys.Control) != Keys.None;
			Keys keyCode = e.KeyCode & Keys.KeyCode;

			if(keyCode == Keys.Oemtilde)
			{
				//Check the control key flag
				if(controlKeyDown)
				{
					if(!flag)
						flag = true;
					else
						flag = false;
					this._grid.Refresh();
				}
			}
		}

		bool flag = false;
		private void _grid_QueryCellFormattedText(object sender, Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs e)
		{
			#region Workaround for formula ReferencesAdjusted while copy/paste a cell range
			if(e.Style.CellType == "FormulaCell")
			{
				GridFormulaCellModel model = ((GridFormulaCellModel)this._grid.CellModels["FormulaCell"]);
				System.Reflection.FieldInfo fi = model.GetType().GetField("isPaste", System.Reflection.BindingFlags.Instance | 
					System.Reflection.BindingFlags.GetField | 
					System.Reflection.BindingFlags.NonPublic);
				fi.SetValue(model, this.isPaste);
			}
			#endregion

			if(e.Style.CellType == "FormulaCell" && flag)
			{
				e.Text = e.Style.Text;
				e.Handled = true;
			}

		}

		private void _grid_CellClick(object sender, Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs e)
		{
			//ĸ̫?
			if(e.ColIndex > 0 && e.RowIndex == 0)
			{				
				if(dir == ListSortDirection.Descending)
					dir = ListSortDirection.Ascending;
				else
					dir = ListSortDirection.Descending;

				if (e.ColIndex == 1 || e.ColIndex == 2)
					_grid.Data.SortByColumn(e.ColIndex, dir,new IntComparer());
				if (e.ColIndex == 3)
					_grid.Data.SortByColumn(e.ColIndex, dir,new StrComparer());
				if (e.ColIndex == 4) 
					_grid.Data.SortByColumn(e.ColIndex, dir,new DateComparer());

				//	this.gridControl1.Data.SortByColumn(e.ColIndex,dir, new NewComparer());
				_grid.Refresh();
			}		
		}

		private void WorkBook_Activated(object sender, System.EventArgs e)
		{
			(this.MdiParent as EditExcel).workBook = this;
			(this.MdiParent as EditExcel).workSheetBarItem.Enabled = true;
			this.RegisterGrid();

		}

		private void WorkBook_Deactivate(object sender, System.EventArgs e)
		{
			(this.MdiParent as EditExcel).workBook = null;
			(this.MdiParent as EditExcel).workSheetBarItem.Enabled = false;
		}


		private void WorkBook_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			////////////////
			///

			EditExcel f = this.MdiParent as EditExcel; 
			//if (f != null) 
			//{ 
				//fǸһʵ
 
			//} 

 			f.FindNodeText(f.tvwCode.Nodes,this.Text);

			/* if (f.tvwCode.Nodes.Count==1)
			 f.tvwCode.Nodes.Clear();*/
			  
			/*int ii;
			for (int ii = 0; i < ChinaCea.MdiChildren[].count; i++)
			if (ChinaCea.MdiChildren[ii].Text=this.Text+"_ֻ")
				ChinaCea.MdiChildren[ii].Close();  */
		}

		private void cutMenuItem_Click(object sender, System.EventArgs e)
		{
			this._grid.Model.CutPaste.Cut();
		}

		private void copyMenuItem_Click(object sender, System.EventArgs e)
		{
			this._grid.Model.CutPaste.Copy();
		}

		private void pasteMenuItem_Click(object sender, System.EventArgs e)
		{
			this._grid.Model.CutPaste.Paste();
		}

		private void deleteMenuItem_Click(object sender, System.EventArgs e)
		{
			this._grid.Model.Clear(true);
		}

		#region Aviod the ReadOnly cell getting pasted...
		private void _grid_SaveCellInfo(object sender, GridSaveCellInfoEventArgs e)
		{
			if (e.RowIndex > 0 && e.ColIndex > 0 && !this._grid.Model.IgnoreReadOnly && e.Style.ReadOnly)
				e.Handled = true;
		}
		#endregion

		private void renameSheetMenuItem_Click(object sender, System.EventArgs e)
		{
			_41388.RenameSheet renameSheet = new _41388.RenameSheet();
			renameSheet.Owner = this;
			if(DialogResult.OK == renameSheet.ShowDialog())
			{
				//have to implement
				MessageBox.Show("Have to implement...");

			}
		}
	}

	# region [  IComparer  ]    //Integer Comparer
	public class IntComparer : IComparer
	{
		#region Implementation of IComparer
		public int Compare(object x, object y)
		{
			if(x == null && y == null)
				return 0;				
			if(x == null)
			{
				return 0;
			}
			else if(y == null)
			{
				return 0;
			}
			else
			{				
				GridStyleInfo xStyle = new GridStyleInfo((GridStyleInfoStore) x);
				GridStyleInfo yStyle = new GridStyleInfo((GridStyleInfoStore) y);
				string xs = xStyle.Text;
				string ys = yStyle.Text;
				double xd = 0;
				double yd = 0;
				double.TryParse(xStyle.Text, System.Globalization.NumberStyles.Any, null, out xd);
				double.TryParse(yStyle.Text, System.Globalization.NumberStyles.Any, null, out yd);
				return xd.CompareTo(yd);

			}
		}
		#endregion
	}
	# endregion


	# region [  IComparer  ]    //String Comparer
	public class StrComparer : IComparer
	{
		#region Implementation of IComparer
		public int Compare(object x, object y)
		{
			if(x == null && y == null)
				return 0;
			if(x == null)
			{
				return 0;
			}
			else if(y == null)
			{
				return 0;
			}
			else
			{
				return (  (IComparable)x.ToString()).CompareTo(y.ToString()  );
			}
		}
		#endregion
	}
	# endregion


	# region [  IComparer  ]    //Date Comparer
	public class DateComparer : IComparer
	{
		#region Implementation of IComparer
		public int Compare(object x, object y)
		{
			if(x == null && y == null)
				return 0;				
			if(x == null)
			{
				return 0;
			}
			else if(y == null)
			{
				return 0;
			}
			else
			{
				GridStyleInfo xStyle = new GridStyleInfo((GridStyleInfoStore) x);
				GridStyleInfo yStyle = new GridStyleInfo((GridStyleInfoStore) y);
				string xs = xStyle.Text;
				string ys = yStyle.Text;
				Console.WriteLine(xs + ":" + ys);
				DateTime xd;
				DateTime yd;
				xd=DateTime.ParseExact(xStyle.Text,null,null);
				yd=DateTime.ParseExact(yStyle.Text,null,null);
				return xd.CompareTo(yd);
			}
		}
		#endregion
	}
	# endregion

	
}
